import xml.etree.ElementTree as ET

from aiohttp import web
from services.basicservice import BasicService
from singleton import Singleton

class ExciseCore(BasicService, metaclass=Singleton):

    def __init__(self):
        super().__init__(__file__)
        self._loadCases('cases.json')

    def getRoutes(self) -> list[web.AbstractRouteDef]:
        return [web.post('/transport/app/entites', handler=self.check)]

    async def check(self, request: web.Request) -> web.Response:
        self.log.info('Запрос к акцизному сервису')
        response = self._createResponse(request.path)

        tree = ET.fromstring(await request.text())
        for placeholders in [["artQty", "QTY_PLCHLDR"], ["artNo", "ARTNO_PLCHLDR"], ["ean", "EAN_PLCHLDR"],
                             ["barcode", "BARCODE_PLCHLDR"]]:
            try:
                value = tree.find(".//" + placeholders[0]).text
                response.text = response.text.replace(placeholders[1], value)
            except Exception as e:
                pass

        return response

instance = ExciseCore()
